using LensSimulatorCore.Shapes;

namespace LensSimulatorCore;

public class LightPathSection
{
    public LightPathSection(PointVector initialPointVector, LightPathProperties properties)
    {
        _properties = properties;
        _initialPointVector = initialPointVector;
    }
    
    private readonly LightPathProperties _properties;
    private readonly PointVector _initialPointVector;
    
    public Point Begin => _initialPointVector.Point;
    public Point? End => GetRayCastHitInfo().HitPosition;

    private RayCastHitInfo GetRayCastHitInfo()
    {
        return true ? new RayCastHitInfo(new (4,5), 3) : null;
    }
}